#.------------------------------------------------------------,
#| Compact Flash Builder - IBM Embedded Linux Network Station |
#|                                                            |
#| This code originally developed by:                         |
#| Ryan Harper and Christopher Glendenning                    |
#| March, April 2000                                          |
#|                                                            |
#| Filename: proginit.tcl                                     |
#| Last Modified: April 26, 2000 by Ryan Harper               |
#| Changes: added quick key, F2, for view log 04.26.00 RAH    |
#|          added new global dir vars 4.7.00 CMG              |
#| Description: contains all of the key bindings and          |
#|     initGlobalVars which initializes all global variables  |
#`------------------------------------------------------------'

global CFBUILD_DIR_NO_SLASH

#-----------------------Key bindings------------------
#Quick menu access keys
bind All <Alt-F> {}
bind All <Alt-B> {}
bind All <Alt-C> {}
bind All <Alt-S> {}
bind All <Alt-U> {}
bind All <Alt-H> {}

#accelerators
bind . <Control-x> {exit .} ;#exit the program
bind . <Control-i> {create_images "0"} ;#Image page
bind . <Control-p> {create_packages "0"} ;#Package page
bind . <Control-d> {choose_settings "0"} ;#Settings page
bind . <Control-m> {choose_settings "0"} ;#Management page
bind . <Control-n> {} ;#Network page
bind . <Control-w> {intro "1"} ;#Start Wizard
bind . <Control-o> {changeOS "0"} ;#Change BaseOS list dialog
bind . <Control-f> {create_partition "0"}  ;#Format page
bind . <Control-u> {create_partition "0"}  ;#Mount page
#bind . <Control-b> {backup_restore "0"} ;#Backup/Restore page
bind . <Control-r> {create_partition "0"} ;#Partition page
bind . <F1> {showAbout} ;#Help About
bind . <F2> {view_log} ;#Open Log File
bind . <F3> {show_help_file "$CFBUILD_DIR_NO_SLASH/IPL" "IBM Corporation License"} ;# Show License

#---------------------End Key bindings-----------------

#---------------------Initialize Globals---------------
# procedure to initialize all global vars needed to run program

proc initGlobalVars {} {
    initStrings
    global CFBUILD_DIR_NO_SLASH
    global CFBUILD_DIR
    global CUSTOM_DIR
    global INSTALLDOC_DIR
    global SCRIPT_DIR
    global BOOTDIR
    global COMMUNICATOR_RPM
    global NAVIGATOR_RPM
    global INSTALL_DEST
    global INSTALL_SOURCE
    global FVWM2_SOURCE
    global FVWM2_ICON_SOURCE
    global BACKUP_SOURCE
    global RESTORE_SOURCE
    global ICACLIENT_RPM
    global TELNET_RPM
    global FTP_RPM
    global CUSTOM_PACKAGE
    global INSTALL_DIR
    global BASEOS_FILELIST
					       
    set BASEOS_FILELIST "$CFBUILD_DIR_NO_SLASH/Scripts/BaseTarFileList.txt"
    set BOOTDIR "/"
    set CUSTOM_DIR "Custom"
    set INSTALLDOC_DIR "Installdocs"
    set SCRIPT_DIR "Scripts"
    set COMMUNICATOR_RPM "/mnt/cdrom/RedHat/RPMS"
    set NAVIGATOR_RPM "/mnt/cdrom/RedHat/RPMS"
    set ICACLIENT_RPM "/mnt/cdrom/RedHat/RPMS"
    set FTP_RPM "/mnt/cdrom/RedHat/RPMS"
    set TELNET_RPM "/mnt/cdrom/RedHat/RPMS"
    set INSTALL_DEST "/"
    set INSTALL_SOURCE "/"
    set FVWM2_SOURCE "/"
    set FVWM2_ICON_SOURCE "/"
    set BACKUP_SOURCE "/"
    set RESTORE_SOURCE "/"
    set INSTALL_DIR "/mnt/hd1"
    set CUSTOM_PACKAGE "/"

    global soundMaster
    global res
    global depth
    global clientServerConfigure
    global clientServerIP
    global clientROMFlash
    global clientCompactFlash

    set soundMaster "50"
    set res "640"
    set depth "8"
    set clientServerConfigure "0"
    set clientServerIP "0.0.0.0"
    set clientROMFlash "1"
    set clientCompactFlash "1"

    global types
    set types {
		{{All Files} {.*}}
		{{Gzip Files} {.gz}}
		{{RPM Files} {.rpm}}
		{{Tar Files} {.tar}}
		{{Tgz Files} {.tgz}}
		{{Z Files} {.Z}}
		}



}
#-------------------End InitGlobs---------------------
