#.------------------------------------------------------------,
#| Compact Flash Builder - IBM NetVista ThinClient Linux      |
#|                                                            |
#| This code originally developed by:                         |
#| Ryan Harper and Christopher Glendenning                    |
#| Copyright 2000                                             |
#|                                                            |
#| Filename: wiz_partition.tcl                                |
#| Last Modified: July 10, 2000 RAH                           |
#| Changes: added System Detection, disabled Part on Server   |
#|          added Init Options, Partition, Format, and Mount  |
#|          added New Interface, remove size options          |
#|          added auto_partition 04.26.00 RAH                 |
#|          added variable dir name support 04.11.00 RAH      |
#| Description: allows user to partition, format, and mount   |
#|              their compact flash                           |
#`------------------------------------------------------------'
proc create_partition {show_next_back} {
	global PARTITION_TITLE
	global PARTITION_WARNING
    check_for_win {.win}
    global lh
    puts $lh [format "%s" "Starting create_partition"]
    puts $lh [format "%s=%s" "Running_in_Wizmode" "$show_next_back"]
    flush $lh
    global CFBUILD_DIR
    global CFBUILD_DIR_NO_SLASH
    global SCRIPT_DIR
    global PARTITION_DIR
	global device_locked

    if {[winfo exists .win]} {
	wm deiconify .win
	return
    }

    set win [toplevel .win -width 400 -height 300]
    wm title .win $PARTITION_TITLE

    centerwin .win
    focus -force .win
    wm resizable .win 0 0

    if {$show_next_back} {
	button .win.next -text {Next >} -command {ChangePage\
	  "create_images" "1"}
	button .win.back -text {< Back} -command {ChangePage\
	  "create_packages" "1"}
	place .win.back -x 8 -y 260
	place .win.next -x 85 -y 260
    }

   label .win.label_warning -justify "left" -text $PARTITION_WARNING

    place .win.label_warning -x 50 -y 20

    frame .win.sep -width 500 -height 2 -borderwidth 2 -relief sunken
    place .win.sep -x 0 -y 245

    button .win.button_partition -width 12 -text "INITIALIZE"\
      -command confirm_partition
    place .win.button_partition -x 275 -y 260
	global partition
	global format
	global mount 

	checkbutton .win.cbPart -offvalue 0 -onvalue 1 -variable partition
	checkbutton .win.cbFormat -offvalue 0 -onvalue 1 -variable format
	checkbutton .win.cbMount -offvalue 0 -onvalue 1 -variable mount
	.win.cbPart select
	.win.cbFormat select
	.win.cbMount select

	label .win.lPart -text "Partition"
	label .win.lFormat -text "Format"
	label .win.lMount -text "Mount"

	place .win.cbPart -x 50 -y 180
	place .win.lPart -x 65 -y 180
	place .win.cbFormat -x 150 -y 180
	place .win.lFormat -x 165 -y 180
	place .win.cbMount -x 250 -y 180
	place .win.lMount -x 265 -y 180

	check_system

    proc confirm_partition {} {
	global PARTITION_SERVER
	global PARTITION_PART_CONFIRM
	global current
	global device_locked
	if { $device_locked } {
		tk_messageBox -message $PARTITION_SERVER ;# ERROR CODE 009
	} else {
		if {[confirm_ask $PARTITION_PART_CONFIRM]} {
		    auto_partition
		}
	}
    }
}

proc auto_partition {} {
	global PARTITION_DONE
	global PARTITION_ERRORS
	global partition
	global format
	global mount
	set retval 1

	if { $partition } { 
		set rv [cf_partition]
		if { $rv == -1 } { set retval -1 }
	}
	if { $format } { 
		set rv [cf_format]
		if { $rv == -1 } { set retval -1 }
	}
	if { $mount } { 
		set rv [cf_mount]
		if { $rv == -1 } { }
	}
	if { $retval } {
		tk_messageBox -message $PARTITION_DONE
	} else {
		tk_messageBox -message $PARTITION_ERRORS ;# ERROR CODE 010
	}
}


proc check_system {} {
	global device_locked
# open /proc/cmdline file to check for root= line,
# if root=nfs, then we have a mounted client, other
# wise, its partition AT YOUR OWN RISK, will disable 
# by default, will have to modify sourcecode to change
# i.e. I dont want to be responsible for reformating
# someones drive with my program. =)
	global lh
	puts $lh "Starting check_system"


	set check_file "/proc/cmdline"
	set hCheckFile [open $check_file r]

	gets $hCheckFile line

	set root [lindex [split [lindex [split $line] 0 ] "="] 1]

	if { [string match $root "nfs"] } { 
		set device_locked 0 
	} else { 
		set device_locked 1
	}

	puts $lh "Running on Server? $device_locked"
	flush $lh
}

	
	
	
